# Copyright 1999-2007 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2

# TODO: we assume "apache" user existance, this is cerainly not correct.
# However, I do not want listing "apache" as depenency as we do not really
# depend on it. What we really need is to get somehow username of currently
# installed webserver. Anyone? ;-)

inherit eutils ruby

DESCRIPTION="Simple HTTP caching service for gravatar images caching"
HOMEPAGE="http://www.ndl.kiev.ua/projects/gravatar.html"
SRC_URI="http://www.ndl.kiev.ua/downloads/${P}.tar.gz"
LICENSE="GPL-2"
SLOT="0"
KEYWORDS="~amd64 ~x86"

DEPEND=">=dev-lang/ruby-1.8
        dev-ruby/ruby-fcgi"

IUSE=""

# Patch applied: reversed --prefix location from 'config' to 'install' section
patched_ruby_einstall() {
	local siteruby

	RUBY_ECONF="${RUBY_ECONF} ${EXTRA_ECONF}"
	if [ -f install.rb ] ; then
		${RUBY} install.rb config "$@" \
			${RUBY_ECONF} || die "install.rb config failed"
		${RUBY} install.rb install --prefix=${D}/usr "$@" \
			${RUBY_ECONF} || die "install.rb install failed"
	elif [ -f setup.rb ] ; then
		${RUBY} setup.rb config "$@" \
			${RUBY_ECONF} || die "setup.rb config failed"
		elog "${RUBY} setup.rb install --prefix=${D}/usr \"$@\""
		${RUBY} setup.rb install --prefix=${D} "$@" \
			${RUBY_ECONF} || die "setup.rb install failed"
	elif [ -f extconf.rb -o -f Makefile ] ; then
		make DESTDIR=${D} "$@" install || die "make install failed"
	else
		siteruby=$(${RUBY} -r rbconfig -e 'print Config::CONFIG["sitedir"]')
		insinto ${siteruby}
		doins *.rb || die "doins failed"
	fi
}

src_install() {
	patched_ruby_einstall "$@" || die

	insinto /etc/gravacacher
	newins ${WORKDIR}/${P}/contrib/gravacacher.yaml ${PN}.yaml
	fperms 600 /etc/gravacacher/${PN}.yaml
	fowners apache:apache /etc/gravacacher/${PN}.yaml

	dodir /var/spool/gravacacher/permanent
        fowners apache:apache /var/spool/gravacacher/permanent
	dodir /var/spool/gravacacher/cached
        fowners apache:apache /var/spool/gravacacher/cached
        dodir /var/log/gravacacher
        fowners apache:apache /var/log/gravacacher
}

pkg_postinst() {
	einfo "A sample configuration file has been installed in /etc/gravacacher/gravacacher.yaml"
	einfo "Please adjust it to your needs, see /usr/share/gravacacher/README.txt "
        einfo "for parameters description and /usr/share/gravacacher/INSTALL.txt "
        einfo "for example of web-server integration."
}
